// @generated by protobuf-ts 2.4.0 with parameter generate_dependencies,// @generated from protobuf file "Math/Math.proto" (package "math", syntax proto3),// tslint:disable
import { ServiceType } from "@protobuf-ts/runtime-rpc";
import type { BinaryWriteOptions } from "@protobuf-ts/runtime";
import type { IBinaryWriter } from "@protobuf-ts/runtime";
import { WireType } from "@protobuf-ts/runtime";
import type { BinaryReadOptions } from "@protobuf-ts/runtime";
import type { IBinaryReader } from "@protobuf-ts/runtime";
import { UnknownFieldHandler } from "@protobuf-ts/runtime";
import type { PartialMessage } from "@protobuf-ts/runtime";
import { reflectionMergePartial } from "@protobuf-ts/runtime";
import { MESSAGE_TYPE } from "@protobuf-ts/runtime";
import { MessageType } from "@protobuf-ts/runtime";
/**
 * @generated from protobuf message math.SumRes
 */
export interface SumRes {
    /**
     * @generated from protobuf field: int64 Summation = 1 [json_name = "Summation"];
     */
    summation: bigint;
}
/**
 * @generated from protobuf message math.SumArg
 */
export interface SumArg {
    /**
     * @generated from protobuf field: repeated int64 Nums = 1 [json_name = "Nums"];
     */
    nums: bigint[];
}
/**
 * @generated from protobuf message math.FactorialRes
 */
export interface FactorialRes {
    /**
     * @generated from protobuf field: int64 Factorial = 1 [json_name = "Factorial"];
     */
    factorial: bigint;
}
/**
 * @generated from protobuf message math.FactorialArg
 */
export interface FactorialArg {
    /**
     * @generated from protobuf field: int64 N = 1 [json_name = "N"];
     */
    n: bigint;
}
// @generated message type with reflection information, may provide speed optimized methods
class SumRes$Type extends MessageType<SumRes> {
    constructor() {
        super("math.SumRes", [
            { no: 1, name: "Summation", kind: "scalar", jsonName: "Summation", T: 3 /*ScalarType.INT64*/, L: 0 /*LongType.BIGINT*/ }
        ]);
    }
    create(value?: PartialMessage<SumRes>): SumRes {
        const message = { summation: 0n };
        globalThis.Object.defineProperty(message, MESSAGE_TYPE, { enumerable: false, value: this });
        if (value !== undefined)
            reflectionMergePartial<SumRes>(this, message, value);
        return message;
    }
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: SumRes): SumRes {
        let message = target ?? this.create(), end = reader.pos + length;
        while (reader.pos < end) {
            let [fieldNo, wireType] = reader.tag();
            switch (fieldNo) {
                case /* int64 Summation = 1 [json_name = "Summation"];*/ 1:
                    message.summation = reader.int64().toBigInt();
                    break;
                default:
                    let u = options.readUnknownField;
                    if (u === "throw")
                        throw new globalThis.Error(`Unknown field ${fieldNo} (wire type ${wireType}) for ${this.typeName}`);
                    let d = reader.skip(wireType);
                    if (u !== false)
                        (u === true ? UnknownFieldHandler.onRead : u)(this.typeName, message, fieldNo, wireType, d);
            }
        }
        return message;
    }
    internalBinaryWrite(message: SumRes, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter {
        /* int64 Summation = 1 [json_name = "Summation"]; */
        if (message.summation !== 0n)
            writer.tag(1, WireType.Varint).int64(message.summation);
        let u = options.writeUnknownFields;
        if (u !== false)
            (u == true ? UnknownFieldHandler.onWrite : u)(this.typeName, message, writer);
        return writer;
    }
}
/**
 * @generated MessageType for protobuf message math.SumRes
 */
export const SumRes = new SumRes$Type();
// @generated message type with reflection information, may provide speed optimized methods
class SumArg$Type extends MessageType<SumArg> {
    constructor() {
        super("math.SumArg", [
            { no: 1, name: "Nums", kind: "scalar", jsonName: "Nums", repeat: 1 /*RepeatType.PACKED*/, T: 3 /*ScalarType.INT64*/, L: 0 /*LongType.BIGINT*/ }
        ]);
    }
    create(value?: PartialMessage<SumArg>): SumArg {
        const message = { nums: [] };
        globalThis.Object.defineProperty(message, MESSAGE_TYPE, { enumerable: false, value: this });
        if (value !== undefined)
            reflectionMergePartial<SumArg>(this, message, value);
        return message;
    }
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: SumArg): SumArg {
        let message = target ?? this.create(), end = reader.pos + length;
        while (reader.pos < end) {
            let [fieldNo, wireType] = reader.tag();
            switch (fieldNo) {
                case /* repeated int64 Nums = 1 [json_name = "Nums"];*/ 1:
                    if (wireType === WireType.LengthDelimited)
                        for (let e = reader.int32() + reader.pos; reader.pos < e;)
                            message.nums.push(reader.int64().toBigInt());
                    else
                        message.nums.push(reader.int64().toBigInt());
                    break;
                default:
                    let u = options.readUnknownField;
                    if (u === "throw")
                        throw new globalThis.Error(`Unknown field ${fieldNo} (wire type ${wireType}) for ${this.typeName}`);
                    let d = reader.skip(wireType);
                    if (u !== false)
                        (u === true ? UnknownFieldHandler.onRead : u)(this.typeName, message, fieldNo, wireType, d);
            }
        }
        return message;
    }
    internalBinaryWrite(message: SumArg, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter {
        /* repeated int64 Nums = 1 [json_name = "Nums"]; */
        if (message.nums.length) {
            writer.tag(1, WireType.LengthDelimited).fork();
            for (let i = 0; i < message.nums.length; i++)
                writer.int64(message.nums[i]);
            writer.join();
        }
        let u = options.writeUnknownFields;
        if (u !== false)
            (u == true ? UnknownFieldHandler.onWrite : u)(this.typeName, message, writer);
        return writer;
    }
}
/**
 * @generated MessageType for protobuf message math.SumArg
 */
export const SumArg = new SumArg$Type();
// @generated message type with reflection information, may provide speed optimized methods
class FactorialRes$Type extends MessageType<FactorialRes> {
    constructor() {
        super("math.FactorialRes", [
            { no: 1, name: "Factorial", kind: "scalar", jsonName: "Factorial", T: 3 /*ScalarType.INT64*/, L: 0 /*LongType.BIGINT*/ }
        ]);
    }
    create(value?: PartialMessage<FactorialRes>): FactorialRes {
        const message = { factorial: 0n };
        globalThis.Object.defineProperty(message, MESSAGE_TYPE, { enumerable: false, value: this });
        if (value !== undefined)
            reflectionMergePartial<FactorialRes>(this, message, value);
        return message;
    }
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: FactorialRes): FactorialRes {
        let message = target ?? this.create(), end = reader.pos + length;
        while (reader.pos < end) {
            let [fieldNo, wireType] = reader.tag();
            switch (fieldNo) {
                case /* int64 Factorial = 1 [json_name = "Factorial"];*/ 1:
                    message.factorial = reader.int64().toBigInt();
                    break;
                default:
                    let u = options.readUnknownField;
                    if (u === "throw")
                        throw new globalThis.Error(`Unknown field ${fieldNo} (wire type ${wireType}) for ${this.typeName}`);
                    let d = reader.skip(wireType);
                    if (u !== false)
                        (u === true ? UnknownFieldHandler.onRead : u)(this.typeName, message, fieldNo, wireType, d);
            }
        }
        return message;
    }
    internalBinaryWrite(message: FactorialRes, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter {
        /* int64 Factorial = 1 [json_name = "Factorial"]; */
        if (message.factorial !== 0n)
            writer.tag(1, WireType.Varint).int64(message.factorial);
        let u = options.writeUnknownFields;
        if (u !== false)
            (u == true ? UnknownFieldHandler.onWrite : u)(this.typeName, message, writer);
        return writer;
    }
}
/**
 * @generated MessageType for protobuf message math.FactorialRes
 */
export const FactorialRes = new FactorialRes$Type();
// @generated message type with reflection information, may provide speed optimized methods
class FactorialArg$Type extends MessageType<FactorialArg> {
    constructor() {
        super("math.FactorialArg", [
            { no: 1, name: "N", kind: "scalar", jsonName: "N", T: 3 /*ScalarType.INT64*/, L: 0 /*LongType.BIGINT*/ }
        ]);
    }
    create(value?: PartialMessage<FactorialArg>): FactorialArg {
        const message = { n: 0n };
        globalThis.Object.defineProperty(message, MESSAGE_TYPE, { enumerable: false, value: this });
        if (value !== undefined)
            reflectionMergePartial<FactorialArg>(this, message, value);
        return message;
    }
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: FactorialArg): FactorialArg {
        let message = target ?? this.create(), end = reader.pos + length;
        while (reader.pos < end) {
            let [fieldNo, wireType] = reader.tag();
            switch (fieldNo) {
                case /* int64 N = 1 [json_name = "N"];*/ 1:
                    message.n = reader.int64().toBigInt();
                    break;
                default:
                    let u = options.readUnknownField;
                    if (u === "throw")
                        throw new globalThis.Error(`Unknown field ${fieldNo} (wire type ${wireType}) for ${this.typeName}`);
                    let d = reader.skip(wireType);
                    if (u !== false)
                        (u === true ? UnknownFieldHandler.onRead : u)(this.typeName, message, fieldNo, wireType, d);
            }
        }
        return message;
    }
    internalBinaryWrite(message: FactorialArg, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter {
        /* int64 N = 1 [json_name = "N"]; */
        if (message.n !== 0n)
            writer.tag(1, WireType.Varint).int64(message.n);
        let u = options.writeUnknownFields;
        if (u !== false)
            (u == true ? UnknownFieldHandler.onWrite : u)(this.typeName, message, writer);
        return writer;
    }
}
/**
 * @generated MessageType for protobuf message math.FactorialArg
 */
export const FactorialArg = new FactorialArg$Type();
/**
 * @generated ServiceType for protobuf service math.MathSvc
 */
export const MathSvc = new ServiceType("math.MathSvc", [
    { name: "Sum", options: {}, I: SumArg, O: SumRes },
    { name: "Factorial", options: {}, I: FactorialArg, O: FactorialRes }
]);
